module.exports = {
  inputs: {
    record: {
      type: 'ref',
      required: true,
    },
    request: {
      type: 'ref',
    },
  },

  async fn(inputs) {
    await BoardMembership.destroy({
      boardId: inputs.record.id,
    }).fetch();

    const board = await Board.archiveOne(inputs.record.id);

    if (board) {
      sails.sockets.removeRoomMembersFromRooms(`board:${board.id}`, `board:${board.id}`);

      const managerUserIds = await sails.helpers.projects.getManagerUserIds(board.projectId);
      const memberUserIds = await sails.helpers.boards.getMemberUserIds(board.id);

      const userIds = _.union(managerUserIds, memberUserIds);

      userIds.forEach((userId) => {
        sails.sockets.broadcast(
          `user:${userId}`,
          'boardDelete',
          {
            item: board,
          },
          inputs.request,
        );
      });
    }

    return board;
  },
};
